# BPF/tracing tools for RDS (Reliable Datagram Socket) protocol SPEC file

%define name        rds-bpf-tools
%define release     19%{?dist}
%define version     0.1
%define _bpfdir	    %{_libdir}/bpf
# find-debuginfo has trouble with BPF programs
%global _enable_debug_package 0
%global debug_package %{nil}
%global __os_install_post /usr/lib/rpm/brp-compress %{nil}


License:        GPL
Name:           %{name}
Summary:        BPF/tracing tools for RDS (Reliable Datagram Socket) protocol
Group:          Development/Tools
Requires:       libbpf >= 0.0.3
BuildRequires:  libbpf-devel >= 0.0.3
BuildRequires:  rh-dotnet20-clang-libs
BuildRequires:  rh-dotnet20-clang
BuildRequires:  rh-dotnet20-llvm-libs
BuildRequires:  rh-dotnet20-llvm
Version:        %{version}
Release:        %{release}
Source:         rds-bpf-tools-%{version}.tar.bz2
Prefix:         %{_prefix}


%description
BPF and tracing tools which utilize tracepoints/kprobes in rds, rds_rdma
and rds_tcp modules to debug systems running RDS.


%prep
%setup -q -n rds-bpf-tools-%{version}


%build
make


%install
rm -Rf %{buildroot}
%make_install


%files
%defattr(-,root,root)
%dir %{_bpfdir}
%dir %{_mandir}/man1
%{_bindir}/rdscheck
%{_bindir}/rdscong
%{_bindir}/rdsconnlat
%{_bindir}/rdslatency
%{_bindir}/rdsrttlatency
%{_bindir}/rdsping
%{_bindir}/rdsq
%{_bindir}/rdsrtt
%{_bindir}/rdssnoop
%{_bindir}/rdsstall
%{_bindir}/rdsstate
%{_bindir}/rds_helloworld
%{_bindir}/rds_mr
%{_bpfdir}/rdscong_kern.o
%{_bpfdir}/rdsconnlat_kern.o
%{_bpfdir}/rdsping_kern.o
%{_bpfdir}/rdsping_server_kern.o
%{_bpfdir}/rdsq_kern.o
%{_bpfdir}/rdsrtt_kern.o
%{_bpfdir}/rdssnoop_kern.o
%{_bpfdir}/rdsstall_kern.o
%{_bpfdir}/rdsstate_kern.o
%{_bpfdir}/rds_helloworld_kern.o
%{_bpfdir}/rds_mr_kern.o
%{_mandir}/man1/rdscheck.1.gz
%{_mandir}/man1/rdscong.1.gz
%{_mandir}/man1/rdsrtt.1.gz
%{_mandir}/man1/rdsrttlatency.1.gz
%{_mandir}/man1/rdsstall.1.gz


%license LICENSE


%changelog
* Thu Nov 18 2021 Alan Maguire <alan.maguire@oracle.com> - 0.1-19
  - initial release
* Wed Nov 17 2021 Alan Maguire <alan.maguire@oracle.com> - 0.1-18
  - address code review feedback [Orabug 33484601]
* Mon Nov 08 2021 Alan Maguire <alan.maguire@oracle.com> - 0.1-17
  - improve error handling in rdsrttlatency
* Wed Oct 27 2021 Alan Maguire <alan.maguire@oracle.com> - 0.1-16
  - fix use of prefix dir
* Tue Oct 26 2021 Alan Maguire <alan.maguire@oracle.com> - 0.1-15
  - fix path to BPF programs
* Tue Oct 26 2021 Alan Maguire <alan.maguire@oracle.com> - 0.1-14
  - fix versioning, use of variables in file paths
* Thu Oct 21 2021 Alan Maguire <alan.maguire@oracle.com> - 0.1-13
  - build for initial release [Orabug: 33484601]
* Thu Oct 21 2021 Alan Maguire <alan.maguire@oracle.com> - 0.1-12
  - greg.jumper@oracle.com rdscong improvements, documentation.
  - rdsrtt improvements (rds-tcp support, clearer timestamps).
  - rdscheck robustness improvements.
* Thu Oct 07 2021 Alan Maguire <alan.maguire@oracle.com> - 0.1-11
  - add greg.jumper@oracle.com 's  rdscong tool for congestion analysis.
* Wed Oct 06 2021 Alan Maguire <alan.maguire@oracle.com> - 0.1-10
  - add manpages for rdsrttlatency, rdsstall etc.
* Thu Sep 30 2021 Alan Maguire <alan.maguire@oracle.com> - 0.1-9
  - extend histogram support, add quiet mode
* Wed Sep 29 2021 Alan Maguire <alan.maguire@oracle.com> - 0.1-8
  - Generalize rdsrtt to support non-ping, add histogram support
* Fri Sep 24 2021 Alan Maguire <alan.maguire@oracle.com> - 0.1-7
  - Fix ssh issue in rdsrttlatency
* Thu Sep 16 2021 Alan Maguire <alan.maguire@oracle.com> - 0.1-6
  - Improvements in rdsrttlatency error handling; timeouts
* Thu Sep 09 2021 Alan Maguire <alan.maguire@oracle.com> - 0.1-5
  - Various spec file fixes courtesy of Aron
  - disable binary stripping (since it doesn't speak bpf)
  - re-enable termination on finding unpackaged files
* Thu Feb 25 2021 Alan Maguire <alan.maguire@oracle.com> - 0.0-1
  - Initial version
